<template>
  <div id="gameBoard">
    <button id="menuBtn" @click="$router.push('/games')">Menu</button>
    <div id="board"></div>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
import Phaser from "phaser";
import { gameConfig, BoardScene } from "./gameBoard";
import { getGame, move, Direction } from "../../../services/backends/world";

@Component
export default class Board extends Vue {
  game?: Phaser.Game;
  gameId = "";

  mounted(): void {
    // Check route params
    this.gameId = this.$route.params.gameId;
    if (!this.gameId) {
      this.$router.push({ name: "Games" });
    } else {
      // Init game
      this.game = new Phaser.Game(gameConfig);
      this.game.events.on("ready", () => this.setupListeners());
    }
  }

  // Board
  getBoardScene(): BoardScene {
    return this.game?.scene.getScene("BoardScene") as BoardScene;
  }

  setupListeners(): void {
    // Listen for the creation of the scene
    this.getBoardScene().onBoardCreated(async() => {
      // Get game map
      const game = await getGame(this.gameId);

      if (!game) {
        this.$router.push({ name: "Games" });
        return;
      }

      this.getBoardScene().setMap(game.map);
    });

    // Listen for moves
    this.getBoardScene().onPlayerMove(async(direction: Direction) => {
      // Get game map
      const gameUpdate = await move(this.gameId, direction);

      if (!gameUpdate) {
        // Illegal move
        return;
      }

      this.getBoardScene().updateGame(gameUpdate);
    });
  }

  beforeDestroy(): void {
    // Destroy the game instance
    this.game?.destroy(true);
  }
}
</script>

<style scoped >
#gameBoard{
  height: 100%;
  overflow: hidden;
}

#menuBtn {
  position: absolute;
  top: 10px;
  left: 10px;
  z-index: 1;
}
</style>
